Aria: ArActionDesired Class Reference

- Main Page
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# ArActionDesired Class Reference

`#include <ArActionDesired.h>`

List of all members.

## Detailed Description

Contains values returned by ArAction objects expressing desired motion commands to resolver.

This class is use by actions to report what want movement commands they want. The action resolver combines the ArActionDesired objects returned by different actions.

A brief summary follows. For a fuller explanation of actions, see actions.

Different values are organized into different "channels". Translational (front/back) and rotational (right/left) movements are separate channels. Translational movement uses velocity, while rotational movement uses change in heading from current heading. Each channel has a strength value. Both translational and rotational movement have maximum velocities as well, that also have their own strengths.

The strength value reflects how strongly an action wants to do the chosen movement command, the resolver (ArResolver) will combine these strengths and figure out what to do based on them.

For all strength values there is a total of 1.0 combined strength avaliable. The range for strength is from 0 to 1. This is simply a convention that ARIA uses by default, if you don't like it, you could override this class the ArResolver class.

Note that for the different maximum/accel/decel values they take an additional argument of whether just to use the slowest speed, slowest accel, or fastest decel. By default these will just use safer values (slowest speed, slowest accel, fastest decel)... you can specify false on these for the old behavior. Note that if you're safest values then the strength is largely ignored though it is still tracked and must still be greater than MIN_STRENGTH to work and it is still capped at MAX_STRENGTH).

See also:
  actions

## Public Member Functions
virtual void | accountForRobotHeading (double robotHeading)
| Accounts for robot heading, mostly internal.
virtual void | addAverage (ArActionDesired *actDesired)
| Adds another actionDesired into the mix to average.
| ArActionDesired ()
| Constructor.
virtual void | endAverage (void)
| Ends the process of avereraging together different desireds.
virtual double | getDeltaHeading (void) const
| Gets the delta heading desired (deg).
virtual double | getDeltaHeadingStrength (void) const
| Gets the strength of the delta heading desired.
virtual double | getHeading (void) const
| Gets the heading desired (deg).
virtual double | getHeadingStrength (void) const
| Gets the strength of the heading desired.
virtual double | getLatAccel (void) const
| Gets the desired lateral acceleration (mm/sec).
virtual double | getLatAccelSlowestUsed (void) const
| Gets whether the slowest lat accel is being used or not.
virtual double | getLatAccelStrength (void) const
| Gets the desired lateral acceleration strength.
virtual double | getLatDecel (void) const
| Gets the desired lateral deceleration (-mm/sec/sec).
virtual double | getLatDecelFastestUsed (void) const
| Gets whether the fastest lat decel is being used or not.
virtual double | getLatDecelStrength (void) const
| Gets the desired lateral deceleration strength.
virtual double | getLatVel (void) const
| Gets the lat vel that was set.
virtual double | getLatVelStrength (void) const
| Gets the lat vel des (deg/sec).
virtual double | getMaxLeftLatVel (void) const
| Gets the maximum lateral velocity.
virtual double | getMaxLeftLatVelSlowestUsed (void) const
| Gets whether the slowest lat vel is being used or not.
virtual double | getMaxLeftLatVelStrength (void) const
| Gets the maximum lateral velocity strength.
virtual double | getMaxNegVel (void) const
| Gets the desired maximum negative velocity (-mm/sec).
virtual double | getMaxNegVelSlowestUsed (void) const
| Gets whether the slowest is being used or not.
virtual double | getMaxNegVelStrength (void) const
| Gets the desired maximum negative velocity strength.
virtual double | getMaxRightLatVel (void) const
| Gets the maximum lateral velocity.
virtual double | getMaxRightLatVelSlowestUsed (void) const
| Gets whether the slowest lat vel is being used or not.
virtual double | getMaxRightLatVelStrength (void) const
| Gets the maximum lateral velocity strength.
virtual double | getMaxRotVel (void) const
| Gets the maximum rotational velocity.
virtual double | getMaxRotVelSlowestUsed (void) const
| Gets whether the slowest rot vel is being used or not.
virtual double | getMaxRotVelStrength (void) const
| Gets the maximum rotational velocity strength.
virtual double | getMaxVel (void) const
| Gets the desired maximum velocity (mm/sec).
virtual double | getMaxVelSlowestUsed (void) const
| Gets whether the slowest is being used or not.
virtual double | getMaxVelStrength (void) const
| Gets the maximum velocity strength.
virtual double | getRotAccel (void) const
| Gets the desired rotational acceleration (mm/sec).
virtual double | getRotAccelSlowestUsed (void) const
| Gets whether the slowest rot accel is being used or not.
virtual double | getRotAccelStrength (void) const
| Gets the desired rotational acceleration strength.
virtual double | getRotDecel (void) const
| Gets the desired rotational deceleration (-mm/sec/sec).
virtual double | getRotDecelFastestUsed (void) const
| Gets whether the fastest rot decel is being used or not.
virtual double | getRotDecelStrength (void) const
| Gets the desired rotational deceleration strength.
virtual double | getRotVel (void) const
| Gets the rot vel that was set.
virtual double | getRotVelStrength (void) const
| Gets the rot vel des (deg/sec).
virtual double | getTransAccel (void) const
| Gets the desired trans acceleration (mm/sec).
virtual double | getTransAccelSlowestUsed (void) const
| Gets whether the slowest accel is being used or not.
virtual double | getTransAccelStrength (void) const
| Gets the desired trans acceleration strength.
virtual double | getTransDecel (void) const
| Gets the desired trans deceleration (-mm/sec/sec).
virtual double | getTransDecelFastestUsed (void) const
| Gets whether the fastest decel is being used or not.
virtual double | getTransDecelStrength (void) const
| Gets the desired trans deceleration strength.
virtual double | getVel (void) const
| Gets the translational velocity desired (mm/sec).
virtual double | getVelStrength (void) const
| Gets the strength of the translational velocity desired.
virtual bool | isAnythingDesired (void) const
| Gets whether anything is desired (should only really be used in relation to logging).
virtual void | log (void) const
| Logs what is desired.
virtual void | merge (ArActionDesired *actDesired)
virtual void | reset (void)
| Resets the strengths to 0.
virtual void | setDeltaHeading (double deltaHeading, double strength=MAX_STRENGTH)
| Sets the delta heading (deg) and strength.
virtual void | setHeading (double heading, double strength=MAX_STRENGTH)
| Sets the absolute heading (deg).
virtual void | setLatAccel (double latAccel, double strength=MAX_STRENGTH, bool useSlowest=true)
| Sets the lateral acceleration (deg/sec/sec) and strength.
virtual void | setLatDecel (double latDecel, double strength=MAX_STRENGTH, bool useFastest=true)
| Sets the lateral deceleration (deg/sec/sec) and strength.
virtual void | setLeftLatVel (double latVel, double strength=MAX_STRENGTH)
| Sets the left lateral velocity (mm/sec) and strength.
virtual void | setMaxLeftLatVel (double maxVel, double strength=MAX_STRENGTH, bool useSlowest=true)
| Sets the maximum lateral velocity (deg/sec) and strength.
virtual void | setMaxNegVel (double maxVel, double strength=MAX_STRENGTH, bool useSlowest=true)
| Sets the maximum velocity for going backwards (-mm/sec) and strength.
virtual void | setMaxRightLatVel (double maxVel, double strength=MAX_STRENGTH, bool useSlowest=true)
| Sets the maximum lateral velocity (deg/sec) and strength.
virtual void | setMaxRotVel (double maxVel, double strength=MAX_STRENGTH, bool useSlowest=true)
| Sets the maximum rotational velocity (deg/sec) and strength.
virtual void | setMaxVel (double maxVel, double strength=MAX_STRENGTH, bool useSlowest=true)
| Sets the maximum velocity (+mm/sec) and strength.
virtual void | setRightLatVel (double latVel, double strength=MAX_STRENGTH)
| Sets the right lateral velocity (mm/sec) and strength.
virtual void | setRotAccel (double rotAccel, double strength=MAX_STRENGTH, bool useSlowest=true)
| Sets the rotational acceleration (deg/sec/sec) and strength.
virtual void | setRotDecel (double rotDecel, double strength=MAX_STRENGTH, bool useFastest=true)
| Sets the rotational deceleration (deg/sec/sec) and strength.
virtual void | setRotVel (double rotVel, double strength=MAX_STRENGTH)
| Sets the rotational velocity.
virtual void | setTransAccel (double transAccel, double strength=MAX_STRENGTH, bool useSlowest=true)
| Sets the translation acceleration (deg/sec/sec) and strength.
virtual void | setTransDecel (double transDecel, double strength=MAX_STRENGTH, bool useFastestDecel=true)
| Sets the translation deceleration (deg/sec/sec) and strength.
virtual void | setVel (double vel, double strength=MAX_STRENGTH)
| Sets the velocity (mm/sec) and strength.
virtual void | startAverage (void)
| Starts the process of avereraging together different desireds.
virtual | ~ArActionDesired ()
| Destructor.
## Static Public Attributes
static const double | MAX_STRENGTH
static const double | MIN_STRENGTH
static const double | NO_STRENGTH
## Protected Attributes
ArActionDesiredChannel | myDeltaHeadingDes
double | myHeading
bool | myHeadingSet
double | myHeadingStrength
ArActionDesiredChannel | myLatAccelDes
ArActionDesiredChannel | myLatDecelDes
ArActionDesiredChannel | myLatVelDes
ArActionDesiredChannel | myMaxLeftLatVelDes
ArActionDesiredChannel | myMaxNegVelDes
ArActionDesiredChannel | myMaxRightLatVelDes
ArActionDesiredChannel | myMaxRotVelDes
ArActionDesiredChannel | myMaxVelDes
ArActionDesiredChannel | myRotAccelDes
ArActionDesiredChannel | myRotDecelDes
ArActionDesiredChannel | myRotVelDes
ArActionDesiredChannel | myTransAccelDes
ArActionDesiredChannel | myTransDecelDes
ArActionDesiredChannel | myVelDes

## Member Function Documentation

virtual void ArActionDesired::accountForRobotHeading | ( | double | robotHeading | ) | `[inline, virtual]`

Accounts for robot heading, mostly internal.

This accounts for the robots heading, and transforms the set heading on this actionDesired into a delta heading so it can be merged and averaged and the like

Parameters:

  | robotHeading | the heading the real actual robot is at now

virtual void ArActionDesired::addAverage | ( | ArActionDesired * | actDesired | ) | `[inline, virtual]`

Adds another actionDesired into the mix to average.

For a description of how to use this, see startAverage.

Parameters:

  | actDesired | the actionDesired to add into the average

virtual void ArActionDesired::endAverage | ( | void |  | ) | `[inline, virtual]`

Ends the process of avereraging together different desireds.

For a description of how to use this, see startAverage.

virtual void ArActionDesired::merge | ( | ArActionDesired * | actDesired | ) | `[inline, virtual]`

This merges in the two different action values, accountForRobotHeading MUST be done before this is called (on both actions), since this merges their delta headings, and the deltas can't be known unless the account for angle is done.

Parameters:

  | actDesired | the actionDesired to merge with this one

virtual void ArActionDesired::setDeltaHeading | ( | double | deltaHeading,
|  | double | strength = `MAX_STRENGTH` |
| ) |  |  | `[inline, virtual]`

Sets the delta heading (deg) and strength.

If there's already a rotVel set this WILL NOT work.

Parameters:

  | deltaHeading | desired change in heading (deg)
  | strength | strength given to this, defaults to MAX_STRENGTH (1.0)

virtual void ArActionDesired::setHeading | ( | double | heading,
|  | double | strength = `MAX_STRENGTH` |
| ) |  |  | `[inline, virtual]`

Sets the absolute heading (deg).

If there's already a rotVel set this WILL NOT work. This is a way to set the heading instead of using a delta, there is no get for this, because accountForRobotHeading MUST be called (this should be called by all resolvers, but if you want to call it you can, thats fine).

Parameters:

  | heading | desired heading (deg)
  | strength | strength given to this, defaults to MAX_STRENGTH (1.0)

virtual void ArActionDesired::setLatAccel | ( | double | latAccel,
|  | double | strength = `MAX_STRENGTH`,
|  | bool | useSlowest = `true` |
| ) |  |  | `[inline, virtual]`

Sets the lateral acceleration (deg/sec/sec) and strength.

This sets the lateral acceleration for this cycle (this is sent down to the robot). Check the ArRobot class notes for more details.

Parameters:

  | latAccel | desired lateral acceleration (deg/sec/sec)
  | strength | strength given to this, defaults to MAX_STRENGTH (1.0)
  | useSlowest | if this is true (the default) everywhere then the slowest lat accel is what will be selected

virtual void ArActionDesired::setLatDecel | ( | double | latDecel,
|  | double | strength = `MAX_STRENGTH`,
|  | bool | useFastest = `true` |
| ) |  |  | `[inline, virtual]`

Sets the lateral deceleration (deg/sec/sec) and strength.

This sets the lateral deceleration for this cycle (this is sent down to the robot). Check the ArRobot class notes for more details.

Parameters:

  | latDecel | desired lateral deceleration (deg/sec/sec)
  | strength | strength given to this, defaults to MAX_STRENGTH (1.0)
  | useFastest | if this is true (the default) everywhere then the fastest lat decel is what will be selected

virtual void ArActionDesired::setLeftLatVel | ( | double | latVel,
|  | double | strength = `MAX_STRENGTH` |
| ) |  |  | `[inline, virtual]`

Sets the left lateral velocity (mm/sec) and strength.

Note that there is only one actual velocity for lat vel, but instead of making people remember which way is left and right there are two functions, setLeftLatVel and setRightLatVel... all setRightLatVel does is flip the direction on the vel. You can set a negative left lat vel and thats the same as setting a positive right vel. You can do the same with setting a negative right vel to get a positive left vel.

Parameters:

  | latVel | desired vel (mm/sec)
  | strength | strength given to this, defaults to MAX_STRENGTH (1.0)

virtual void ArActionDesired::setMaxLeftLatVel | ( | double | maxVel,
|  | double | strength = `MAX_STRENGTH`,
|  | bool | useSlowest = `true` |
| ) |  |  | `[inline, virtual]`

Sets the maximum lateral velocity (deg/sec) and strength.

This sets the maximum lateral velocity for this cycle. Check the ArRobot class notes for more details.

Parameters:

  | maxVel | desired maximum lateral velocity (deg/sec)
  | strength | strength given to this, defaults to MAX_STRENGTH (1.0)
  | useSlowest | if this is true (the default) everywhere then the slowest lat vel is what will be selected

virtual void ArActionDesired::setMaxNegVel | ( | double | maxVel,
|  | double | strength = `MAX_STRENGTH`,
|  | bool | useSlowest = `true` |
| ) |  |  | `[inline, virtual]`

Sets the maximum velocity for going backwards (-mm/sec) and strength.

This sets the maximum negative velocity for this cycle. Check the ArRobot class notes for more details.

Parameters:

  | maxVel | desired maximum velocity for going backwards (-mm/sec)
  | strength | strength given to this, defaults to MAX_STRENGTH (1.0)
  | useSlowest | if this is true (the default) everywhere then the slowest max neg vel is what will be selected

virtual void ArActionDesired::setMaxRightLatVel | ( | double | maxVel,
|  | double | strength = `MAX_STRENGTH`,
|  | bool | useSlowest = `true` |
| ) |  |  | `[inline, virtual]`

Sets the maximum lateral velocity (deg/sec) and strength.

This sets the maximum lateral velocity for this cycle. Check the ArRobot class notes for more details.

Parameters:

  | maxVel | desired maximum lateral velocity (deg/sec)
  | strength | strength given to this, defaults to MAX_STRENGTH (1.0)
  | useSlowest | if this is true (the default) everywhere then the slowest lat vel is what will be selected

virtual void ArActionDesired::setMaxRotVel | ( | double | maxVel,
|  | double | strength = `MAX_STRENGTH`,
|  | bool | useSlowest = `true` |
| ) |  |  | `[inline, virtual]`

Sets the maximum rotational velocity (deg/sec) and strength.

This sets the maximum rotational velocity for this cycle (this is sent down to the robot). Check the ArRobot class notes for more details.

Parameters:

  | maxVel | desired maximum rotational velocity (deg/sec)
  | strength | strength given to this, defaults to MAX_STRENGTH (1.0)
  | useSlowest | if this is true (the default) everywhere then the slowest rot vel is what will be selected

virtual void ArActionDesired::setMaxVel | ( | double | maxVel,
|  | double | strength = `MAX_STRENGTH`,
|  | bool | useSlowest = `true` |
| ) |  |  | `[inline, virtual]`

Sets the maximum velocity (+mm/sec) and strength.

This sets the maximum positive velocity for this cycle. Check the ArRobot class notes for more details.

Parameters:

  | maxVel | desired maximum velocity (+mm/sec)
  | strength | strength given to this, defaults to MAX_STRENGTH (1.0)
  | useSlowest | if this is true (the default) everywhere then the slowest maximum vel is what will be selected

virtual void ArActionDesired::setRightLatVel | ( | double | latVel,
|  | double | strength = `MAX_STRENGTH` |
| ) |  |  | `[inline, virtual]`

Sets the right lateral velocity (mm/sec) and strength.

Note that there is only one actual velocity for lat vel, but instead of making people remember which way is left and right there are two functions, setLeftLatVel and setRightLatVel... all setRightLatVel does is flip the direction on the vel. You can set a negative left lat vel and thats the same as setting a positive right vel. You can do the same with setting a negative right vel to get a positive left vel.

Parameters:

  | latVel | desired vel (mm/sec)
  | strength | strength given to this, defaults to MAX_STRENGTH (1.0)

virtual void ArActionDesired::setRotAccel | ( | double | rotAccel,
|  | double | strength = `MAX_STRENGTH`,
|  | bool | useSlowest = `true` |
| ) |  |  | `[inline, virtual]`

Sets the rotational acceleration (deg/sec/sec) and strength.

This sets the rotational acceleration for this cycle (this is sent down to the robot). Check the ArRobot class notes for more details.

Parameters:

  | rotAccel | desired rotational acceleration (deg/sec/sec)
  | strength | strength given to this, defaults to MAX_STRENGTH (1.0)
  | useSlowest | if this is true (the default) everywhere then the slowest rot accel is what will be selected

virtual void ArActionDesired::setRotDecel | ( | double | rotDecel,
|  | double | strength = `MAX_STRENGTH`,
|  | bool | useFastest = `true` |
| ) |  |  | `[inline, virtual]`

Sets the rotational deceleration (deg/sec/sec) and strength.

This sets the rotational deceleration for this cycle (this is sent down to the robot). Check the ArRobot class notes for more details.

Parameters:

  | rotDecel | desired rotational deceleration (deg/sec/sec)
  | strength | strength given to this, defaults to MAX_STRENGTH (1.0)
  | useFastest | if this is true (the default) everywhere then the fastest rot decel is what will be selected

virtual void ArActionDesired::setRotVel | ( | double | rotVel,
|  | double | strength = `MAX_STRENGTH` |
| ) |  |  | `[inline, virtual]`

Sets the rotational velocity.

If there's already a delta heading or heading this WILL NOT work.

Parameters:

  | rotVel | desired rotational velocity (deg/sec)
  | strength | strength given to this, defaults to MAX_STRENGTH (1.0)

virtual void ArActionDesired::setTransAccel | ( | double | transAccel,
|  | double | strength = `MAX_STRENGTH`,
|  | bool | useSlowest = `true` |
| ) |  |  | `[inline, virtual]`

Sets the translation acceleration (deg/sec/sec) and strength.

This sets the translation acceleration for this cycle (this is sent down to the robot). Check the ArRobot class notes for more details.

Parameters:

  | transAccel | desired translation acceleration (deg/sec/sec)
  | strength | strength given to this, defaults to MAX_STRENGTH (1.0)
  | useSlowest | if this is true (the default) everywhere then the slowest accel is what will be selected

virtual void ArActionDesired::setTransDecel | ( | double | transDecel,
|  | double | strength = `MAX_STRENGTH`,
|  | bool | useFastestDecel = `true` |
| ) |  |  | `[inline, virtual]`

Sets the translation deceleration (deg/sec/sec) and strength.

This sets the translation deceleration for this cycle (this is sent down to the robot). Check the ArRobot class notes for more details.

Parameters:

  | transDecel | desired translation deceleration (deg/sec/sec)
  | strength | strength given to this, defaults to MAX_STRENGTH (1.0)
  | useFastestDecel | if this is true (the default) everywhere then the fastest decel is what will be selected

virtual void ArActionDesired::setVel | ( | double | vel,
|  | double | strength = `MAX_STRENGTH` |
| ) |  |  | `[inline, virtual]`

Sets the velocity (mm/sec) and strength.

Parameters:

  | vel | desired vel (mm/sec)
  | strength | strength given to this, defaults to MAX_STRENGTH (1.0)

virtual void ArActionDesired::startAverage | ( | void |  | ) | `[inline, virtual]`

Starts the process of avereraging together different desireds.

There is a three step process for averaging actionDesireds together, first startAverage must be done to set up the process, then addAverage must be done with each average that is desired, then finally endAverage should be used, after that is done then the normal process of getting the results out should be done.

The documentation for this class was generated from the following file:

- ArActionDesired.h